/***************************************************************************
                          player.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/
/***************************************************************************
  The original vergion of Kvirus is Ataxxlet written in JAVA
    by Paul Buchheit <ptb@po.cwru.edu>
  Kvirus is KDE port of Ataxxlet.
****************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "player.h"

Player::Player(){
}

Player::Player(int player){
  this->player=player;
  m=new Move();
}

Player::Player(Board *b, int player){
  this->player=player;
  this->b=b;
  m=new Move();
}

Player::~Player(){
}

void Player::setplayer(int player){
  this->player=player;
}

int Player::getplayer(){
  return(this->player);
}

float Player::findGoodMove(){
  float selfGoNear, selfGoAway, enemyGoNear;
  float score;
  selfGoNear=0;
  selfGoAway=0;
  enemyGoNear=0;
  for(int x=-1;x<2;x++)
    for(int y=-1;y<2;y++)
      if((x!=0)||(y!=0)){
          if(b->isOnBoard(m->gettoX()+x, m->gettoY()+y)){
          if(b->getSpot(m->gettoX()+x, m->gettoY()+y)==this->player)
            selfGoNear+=1;
          if(b->isEnemy(this->player, m->gettoX()+x, m->gettoY()+y))
            enemyGoNear +=1;
        }
        if(b->isOnBoard(m->getfromX()+x, m->getfromY()+y)==this->player)
          selfGoAway+=1;
    }
  score=enemyGoNear + 0.2*selfGoNear;
  if(m->distance()>1)
    score -=selfGoAway*0.2;
  else
    score +=1;
  if(b->isGoingToWall(m))
    score +=0.05;
  return (score);
}

Move* Player::findBestMove(){
  Move *best;
  float score, bestscore=-42;
  best =new Move();
  m->resetMove();

  while(b->advanceLegalMove(m, this->player)){
    score=findGoodMove();
    if(score>bestscore){
      best->fromX=m->fromX;
      best->fromY=m->fromY;
      best->toX=m->toX;
      best->toY=m->toY;
      bestscore=score;
    }
  }
  return(best);
}














