/***************************************************************************
                          player.h  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef PLAYER_H
#define PLAYER_H

#include "board.h"
#include "move.h"

/**
  *@author Sung Soo Kang
  */

class Player {
public: 
	Player();
	Player(int);
	Player(Board *, int);
	~Player();
	

	Move *m;
	Board *b;

	int player;
	

	void setplayer(int);
	int getplayer();
	
	float findGoodMove();
	Move* findBestMove();
	
	
};

#endif






