/***************************************************************************
                          move.cpp  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/
/***************************************************************************
  The original vergion of Kvirus is Ataxxlet written in JAVA
    by Paul Buchheit <ptb@po.cwru.edu>
  Kvirus is KDE port of Ataxxlet.
****************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#include "move.h"

Move::Move(){

}
Move::Move(int fromX, int fromY, int toX, int toY){
  this->fromX=fromX;
  this->fromY=fromY;
  this->toX=toX;
  this->toY=toY;
}

Move::~Move(){
}

int Move::getfromX(){
  return(this->fromX);
}

void Move::setfromX(int fromX){
  this->fromX=fromX;
}

int Move::getfromY(){
  return(this->fromY);
}

void Move::setfromY(int fromY){
  this->fromY=fromY;
}

int Move::gettoX(){
  return(this->toX);
}

void Move::settoX(int toX){
  this->toX=toX;
}

int Move::gettoY(){
  return(this->toY);
}

void Move::settoY(int toY){
  this->toY=toY;
}


int Move::distance(){
  return(max(abs(this->getfromX()-this->gettoX()), abs(this->getfromY()-this->gettoY())));
}

void Move::resetMove(){
  this->fromX=0;
  this->fromY=0;
  this->toX=-2;
  this->toY=-2;
}





