/***************************************************************************
                          move.h  -  description                              
                             -------------------                                         
    begin                : Sat Jun 12 1999                                           
    copyright            : (C) 1999 by Sung Soo Kang                         
    email                : skang5@po-box.mcgill.ca                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef MOVE_H
#define MOVE_H


/**
  *@author Sung Soo Kang
  */

template <class Type>
  Type max(Type a, Type b){
    return ((a-b)>0?a:b);
}

class Move {
public: 
	Move();
	Move(int, int, int, int);
	~Move();
	
  int fromX;
  int fromY;
  int toX;
  int toY;

  int getfromX();
  void setfromX(int);
  int getfromY();
  void setfromY(int);
  int gettoX();
  void settoX(int);
  int gettoY();
  void settoY(int);

  int distance();
  void resetMove();
};

#endif








